@echo off
:: This patcher script was evolved by Immorpher, Phredreeke, Molecicco and scwiba; this first section can be edited
	echo The UnMaking version 1.0, for the official Doom 64 Remaster

	:: Define WAD name
	set WADFile=the_unmaking.wad

	:: Define what the Doom64.kpf file should be after patching; not required but can prevent double patching
	set /A PatchSize = 7069980

:: --------------------------------------------------------------------------------------------------
:: Be careful editing after this point

:: Look for the GOG installation of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\GOG.com\Games\1456611261" /v path 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto kpfpatch
	
:: Look for the Steam installation of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Steam App 1148590" /v InstallLocation 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto kpfpatch

:: Look for Bethesda version
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\DOOM 64\" /v Path 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto kpfpatch
	
:: Look for Game Pass version
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_CLASSES_ROOT\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppModel\Repository\Packages\BethesdaSoftworks.Doom641997_1.4.0.0_x64__3275kfvn8vcwc" /v PackageRootFolder 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf" goto kpfpatch
	
:: Look for a local file
	:: Set the directory locally and check if the WAD is there
	set appdir=
	if exist "%appdir%Doom64.kpf" goto kpfpatch
	
:: If no KPF found notify user
	goto notfound
	
	
:: If found try patching and run the mod
:kpfpatch
	:: Check DoomKPF file size to avoid double patchin
	for %%I in ("%appdir%Doom64.kpf") do ( 
		set size=%%~zI
		)
		
	:: If already patched run WAD
	if "%size%" == "%PatchSize%" goto runwad

	:: Make back up of the original KPF files if backups dont exist
	echo Backing up KPF files...
	if not exist "%appdir%Doom64.kpf.bak" copy "%appdir%Doom64.kpf" "%appdir%Doom64.kpf.bak" >NUL
	if not exist "%appdir%BNet.kpf.bak" copy "%appdir%BNet.kpf" "%appdir%BNet.kpf.bak" >NUL
	
	:: Check if backing up worked
	if not exist "%appdir%Doom64.kpf.bak" goto writeprotected
	
	echo Patching KPF files...
	:: Extract found Doom 64 KPF to the Doom64KPF working directory
	"kpf\7za.exe" x -tzip "%appdir%Doom64.kpf" -o"%appdir%Doom64KPF"
	:: Copy custom Doom64.kpf files into Doom64KPF working directory
	xcopy "kpf\Doom64" "%appdir%Doom64KPF" /E /Y
	:: Regenerate KPF file
	"kpf\7za.exe" a -tzip "%appdir%Doom64.kpf" "%appdir%Doom64KPF\*"
	:: Clean up Doom64KPF working directory
	rmdir "%appdir%Doom64KPF" /S /Q
	
	:: Done patching and time to play the game
	goto :runwad

:: Unable to find the files to patch
:notfound
	echo Failed to find the KPF files to patch - Attempting to load WAD
	goto :runwad

:: Unable to save file
:writeprotected
	echo Unable apply KPF patch - Administrator privileges may be required
	goto :runwad
	
:: Try to run the WAD
:runwad
	echo Loading the mod... Check for any window prompts!
	"%appdir%DOOM64_x64" -file "%cd%\%WADFile%" -skipmovies
	pause
	goto :eof